/**
  * @file fls_nor_flash.h
  * @author generated by mrt-device utility 
  * @link [https://github.com/uprev-mrt/mrtutils/wiki/mrt-device]
  * @brief Device driver for fls_nor_flash device
  *
  *
  */

#ifdef __cplusplus
extern "C"
{
#endif

/* Includes ------------------------------------------------------------------*/
#include <stdint.h>
#include <stdbool.h>
#include "Devices/RegDevice/register_device.h"
#include "fls_nor_flash_regs.h"

/*user-block-top-start*/
/*user-block-top-end*/


/* Exported types ------------------------------------------------------------*/

typedef struct{
    mrt_regdev_t mRegDev;            //ptr to base register-device 
    mrt_reg_t mStatus;               //Status Register
    mrt_reg_t mConfig;               //Configuration Register
    mrt_reg_t mBankAddr;             //Bank Address Register
    mrt_reg_t mSecErase;             //Sector Erase command
    mrt_reg_t mBulkErase;            //Bulk Erase command
    mrt_reg_t mProgData;             //Page Program command
    mrt_reg_t mReadData;             //Read Data command
/*user-block-struct-start*/
/*user-block-struct-end*/
}fls_nor_flash_t;


/* Exported functions ------------------------------------------------------- */


/**
 * @brief initializes fls_nor_flash device for i2c bus
 * @param dev ptr to fls_nor_flash device
 * @param spi handle for i2c bus
 */
mrt_status_t fls_init_spi(fls_nor_flash_t* dev, mrt_spi_handle_t spi, mrt_gpio_t chipSelect );

/**
  *@brief tests interface with device
  *@param dev ptr to fls_nor_flash device
  *@return MRT_STATUS_OK if test is passed 
  *@return MRT_STATUS_ERROR if test fails
  */
mrt_status_t fls_test(fls_nor_flash_t* dev);

/**
  *@brief writes register of device
  *@param dev ptr to fls_nor_flash device
  *@param reg ptr to register definition
  *@param data data to be write
  *@return status (type defined by platform)
  */
#define fls_write_reg(dev, reg, data) regdev_write_reg(&(dev)->mRegDev, (reg), (data))

/**
  *@brief reads register of device
  *@param dev ptr to fls_nor_flash device
  *@param reg ptr to register definition
  *@param data ptr to store data
  *@return value of register
  */
#define fls_read_reg(dev, reg) regdev_read_reg(&(dev)->mRegDev, (reg))


/*user-block-bottom-start*/

/*user-block-bottom-end*/

#ifdef __cplusplus
}
#endif